/* Actions (message types) */
mtype = { nop, c5_t10, c5_t9, c5_t5, c5_t4, c4_t18, c4_t14, c4_t13, c4_t15, c4_t19, c4_t12, c4_t9, c4_t6, c4_t7, c4_t3, c4_t2, c4_t1, c4_t5, c4_t0, c3_t11, c3_t8, c3_t5, c3_t4, c3_t12, c3_t0, c5_t2__c2_t9, c3_t3__c2_t10, c5_t0__c2_t13, c2_t6, c3_t7, c5_t1, c2_t4, c2_t0, c2_t12, c2_t8__c1_t4, c4_t4, c2_t5__c5_t7, c5_t8__c1_t2, c2_t7, c1_t5__c3_t10, c1_t8, c4_t17, c5_t6, c1_t6, c1_t3, c2_t14, c1_t1, c1_t0, c3_t6__c2_t2, c1_t7, c2_t1__c0_t3, c0_t0__c2_t3, c3_t9, c1_t9, c0_t7, c4_t10, c4_t16, c0_t9, c0_t6, c3_t1, c0_t5, c0_t4, c0_t8__c2_t11, c0_t2, c4_t8, c5_t3, c0_t1, c4_t11, c5_t11, c3_t2 };

/* Inter-process channels */
chan p5_2 = [0] of {mtype};
chan p3_2 = [0] of {mtype};
chan p2_1 = [0] of {mtype};
chan p5_1 = [0] of {mtype};
chan p3_1 = [0] of {mtype};
chan p2_0 = [0] of {mtype};

/* Environement<->process channels */
chan p5 = [0] of {mtype};
chan p4 = [0] of {mtype};
chan p3 = [0] of {mtype};
chan p2 = [0] of {mtype};
chan p1 = [0] of {mtype};
chan p0 = [0] of {mtype};

/* Environment process */
active proctype Environment()
{
  do
  :: p5 ! c5_t10
  :: p5 ! c5_t9
  :: p5 ! c5_t5
  :: p5 ! c5_t4
  :: p4 ! c4_t18
  :: p4 ! c4_t14
  :: p4 ! c4_t13
  :: p4 ! c4_t15
  :: p4 ! c4_t19
  :: p4 ! c4_t12
  :: p4 ! c4_t9
  :: p4 ! c4_t6
  :: p4 ! c4_t7
  :: p4 ! c4_t3
  :: p4 ! c4_t2
  :: p4 ! c4_t1
  :: p4 ! c4_t5
  :: p4 ! c4_t0
  :: p3 ! c3_t11
  :: p3 ! c3_t8
  :: p3 ! c3_t5
  :: p3 ! c3_t4
  :: p3 ! c3_t12
  :: p3 ! c3_t0
  :: p2 ! c2_t6
  :: p3 ! c3_t7
  :: p5 ! c5_t1
  :: p2 ! c2_t4
  :: p2 ! c2_t0
  :: p2 ! c2_t12
  :: p4 ! c4_t4
  :: p2 ! c2_t7
  :: p1 ! c1_t8
  :: p4 ! c4_t17
  :: p5 ! c5_t6
  :: p1 ! c1_t6
  :: p1 ! c1_t3
  :: p2 ! c2_t14
  :: p1 ! c1_t1
  :: p1 ! c1_t0
  :: p1 ! c1_t7
  :: p3 ! c3_t9
  :: p1 ! c1_t9
  :: p0 ! c0_t7
  :: p4 ! c4_t10
  :: p4 ! c4_t16
  :: p0 ! c0_t9
  :: p0 ! c0_t6
  :: p3 ! c3_t1
  :: p0 ! c0_t5
  :: p0 ! c0_t4
  :: p0 ! c0_t2
  :: p4 ! c4_t8
  :: p5 ! c5_t3
  :: p5 ! nop
  :: p4 ! nop
  :: p3 ! nop
  :: p2 ! nop
  :: p1 ! nop
  :: p0 ! nop
  :: p0 ! c0_t1
  :: p4 ! c4_t11
  :: p5 ! c5_t11
  :: p3 ! c3_t2
  od
}

/* Action channel */
chan act = [0] of {mtype};

/* Most recent message event */
mtype lastAction = nop;

/* Action listener */
active proctype Listener()
{
  atomic {
    do
    :: act ? lastAction ->
  step: skip
    od
  }
}

/* Process 0 */
active proctype Proc0()
{
  int state = 0;
  do
  :: state == 0 ->
    atomic {
      if
      :: p0 ? nop ->

        state = 6;
      fi
    }
  :: state == 6 ->
    atomic {
      if
      :: p0 ? c0_t5 ->
        act ! c0_t5;
        state = 1;
      fi
    }
  :: state == 1 ->
    atomic {
      if
      :: p2_0 ? c0_t0__c2_t3 ->
        act ! c0_t0__c2_t3;
        state = 2;
      fi
    }
  :: state == 2 ->
    atomic {
      if
      :: p0 ? c0_t1 ->
        act ! c0_t1;
        state = 3;
      fi
    }
  :: state == 3 ->
    atomic {
      if
      :: p0 ? c0_t2 ->
        act ! c0_t2;
        state = 4;
      fi
    }
  :: state == 4 ->
    atomic {
      if
      :: p0 ? c0_t9 ->
        act ! c0_t9;
        state = 7;
      :: p2_0 ? c2_t1__c0_t3 ->
        act ! c2_t1__c0_t3;
        state = 5;
      fi
    }
  :: state == 7 ->
    atomic {
      if
      :: p0 ? c0_t6 ->
        act ! c0_t6;
        state = 8;
      fi
    }
  :: state == 5 ->
    atomic {
      if
      :: p0 ? c0_t4 ->
        act ! c0_t4;
        state = 6;
      fi
    }
  :: state == 8 ->
    atomic {
      if
      :: p0 ? c0_t7 ->
        act ! c0_t7;
        state = 9;
      fi
    }
  :: state == 9 ->
    atomic {
      if
      :: p2_0 ? c0_t8__c2_t11 ->
        act ! c0_t8__c2_t11;
        state = 4;
      fi
    }
  od
}

/* Process 1 */
active proctype Proc1()
{
  int state = 10;
  do
  :: state == 10 ->
    atomic {
      if
      :: p1 ? nop ->

        state = 11;
      fi
    }
  :: state == 11 ->
    atomic {
      if
      :: p1 ? c1_t0 ->
        act ! c1_t0;
        state = 12;
      fi
    }
  :: state == 12 ->
    atomic {
      if
      :: p1 ? c1_t1 ->
        act ! c1_t1;
        state = 13;
      fi
    }
  :: state == 13 ->
    atomic {
      if
      :: p1 ? c1_t8 ->
        act ! c1_t8;
        state = 18;
      :: p3_1 ? c1_t5__c3_t10 ->
        act ! c1_t5__c3_t10;
        state = 16;
      :: p5_1 ? c5_t8__c1_t2 ->
        act ! c5_t8__c1_t2;
        state = 14;
      fi
    }
  :: state == 18 ->
    atomic {
      if
      :: p1 ? c1_t9 ->
        act ! c1_t9;
        state = 17;
      fi
    }
  :: state == 16 ->
    atomic {
      if
      :: p1 ? c1_t6 ->
        act ! c1_t6;
        state = 15;
      fi
    }
  :: state == 14 ->
    atomic {
      if
      :: p1 ? c1_t3 ->
        act ! c1_t3;
        state = 11;
      fi
    }
  :: state == 17 ->
    atomic {
      if
      :: p1 ? c1_t7 ->
        act ! c1_t7;
        state = 13;
      fi
    }
  :: state == 15 ->
    atomic {
      if
      :: p2_1 ? c2_t8__c1_t4 ->
        act ! c2_t8__c1_t4;
        state = 13;
      fi
    }
  od
}

/* Process 2 */
active proctype Proc2()
{
  int state = 19;
  do
  :: state == 19 ->
    atomic {
      if
      :: p2 ? nop ->

        state = 26;
      fi
    }
  :: state == 26 ->
    atomic {
      if
      :: p2 ? c2_t6 ->
        act ! c2_t6;
        state = 27;
      fi
    }
  :: state == 27 ->
    atomic {
      if
      :: p2 ? c2_t7 ->
        act ! c2_t7;
        state = 24;
      fi
    }
  :: state == 24 ->
    atomic {
      if
      :: p2 ? c2_t4 ->
        act ! c2_t4;
        state = 20;
      :: p2_1 ! c2_t8__c1_t4 ->

        state = 25;
      fi
    }
  :: state == 20 ->
    atomic {
      if
      :: p2 ? c2_t0 ->
        act ! c2_t0;
        state = 21;
      fi
    }
  :: state == 25 ->
    atomic {
      if
      :: p5_2 ? c2_t5__c5_t7 ->
        act ! c2_t5__c5_t7;
        state = 26;
      fi
    }
  :: state == 21 ->
    atomic {
      if
      :: p2_0 ! c2_t1__c0_t3 ->

        state = 22;
      fi
    }
  :: state == 22 ->
    atomic {
      if
      :: p3_2 ? c3_t6__c2_t2 ->
        act ! c3_t6__c2_t2;
        state = 23;
      fi
    }
  :: state == 23 ->
    atomic {
      if
      :: p2 ? c2_t12 ->
        act ! c2_t12;
        state = 30;
      :: p2_0 ! c0_t0__c2_t3 ->

        state = 24;
      :: p3_2 ? c3_t3__c2_t10 ->
        act ! c3_t3__c2_t10;
        state = 29;
      fi
    }
  :: state == 30 ->
    atomic {
      if
      :: p5_2 ? c5_t0__c2_t13 ->
        act ! c5_t0__c2_t13;
        state = 31;
      fi
    }
  :: state == 29 ->
    atomic {
      if
      :: p2_0 ! c0_t8__c2_t11 ->

        state = 23;
      fi
    }
  :: state == 31 ->
    atomic {
      if
      :: p2 ? c2_t14 ->
        act ! c2_t14;
        state = 28;
      fi
    }
  :: state == 28 ->
    atomic {
      if
      :: p5_2 ? c5_t2__c2_t9 ->
        act ! c5_t2__c2_t9;
        state = 23;
      fi
    }
  od
}

/* Process 3 */
active proctype Proc3()
{
  int state = 32;
  do
  :: state == 32 ->
    atomic {
      if
      :: p3 ? nop ->

        state = 39;
      fi
    }
  :: state == 39 ->
    atomic {
      if
      :: p3 ? c3_t7 ->
        act ! c3_t7;
        state = 37;
      :: p3 ? c3_t9 ->
        act ! c3_t9;
        state = 40;
      fi
    }
  :: state == 37 ->
    atomic {
      if
      :: p3 ? c3_t4 ->
        act ! c3_t4;
        state = 33;
      :: p3 ? c3_t5 ->
        act ! c3_t5;
        state = 38;
      :: p3 ? c3_t8 ->
        act ! c3_t8;
        state = 37;
      fi
    }
  :: state == 40 ->
    atomic {
      if
      :: p3_1 ! c1_t5__c3_t10 ->

        state = 41;
      fi
    }
  :: state == 33 ->
    atomic {
      if
      :: p3 ? c3_t0 ->
        act ! c3_t0;
        state = 34;
      fi
    }
  :: state == 38 ->
    atomic {
      if
      :: p3_2 ! c3_t6__c2_t2 ->

        state = 39;
      fi
    }
  :: state == 41 ->
    atomic {
      if
      :: p3 ? c3_t11 ->
        act ! c3_t11;
        state = 42;
      fi
    }
  :: state == 34 ->
    atomic {
      if
      :: p3 ? c3_t1 ->
        act ! c3_t1;
        state = 35;
      fi
    }
  :: state == 42 ->
    atomic {
      if
      :: p3 ? c3_t12 ->
        act ! c3_t12;
        state = 39;
      fi
    }
  :: state == 35 ->
    atomic {
      if
      :: p3 ? c3_t2 ->
        act ! c3_t2;
        state = 36;
      fi
    }
  :: state == 36 ->
    atomic {
      if
      :: p3_2 ! c3_t3__c2_t10 ->

        state = 37;
      fi
    }
  od
}

/* Process 4 */
active proctype Proc4()
{
  int state = 43;
  do
  :: state == 43 ->
    atomic {
      if
      :: p4 ? nop ->

        state = 47;
      fi
    }
  :: state == 47 ->
    atomic {
      if
      :: p4 ? c4_t3 ->
        act ! c4_t3;
        state = 48;
      :: p4 ? c4_t16 ->
        act ! c4_t16;
        state = 57;
      fi
    }
  :: state == 48 ->
    atomic {
      if
      :: p4 ? c4_t4 ->
        act ! c4_t4;
        state = 44;
      :: p4 ? c4_t8 ->
        act ! c4_t8;
        state = 49;
      fi
    }
  :: state == 57 ->
    atomic {
      if
      :: p4 ? c4_t17 ->
        act ! c4_t17;
        state = 58;
      fi
    }
  :: state == 44 ->
    atomic {
      if
      :: p4 ? c4_t0 ->
        act ! c4_t0;
        state = 45;
      fi
    }
  :: state == 49 ->
    atomic {
      if
      :: p4 ? c4_t5 ->
        act ! c4_t5;
        state = 50;
      fi
    }
  :: state == 58 ->
    atomic {
      if
      :: p4 ? c4_t18 ->
        act ! c4_t18;
        state = 59;
      fi
    }
  :: state == 45 ->
    atomic {
      if
      :: p4 ? c4_t1 ->
        act ! c4_t1;
        state = 46;
      fi
    }
  :: state == 50 ->
    atomic {
      if
      :: p4 ? c4_t6 ->
        act ! c4_t6;
        state = 51;
      :: p4 ? c4_t11 ->
        act ! c4_t11;
        state = 54;
      fi
    }
  :: state == 59 ->
    atomic {
      if
      :: p4 ? c4_t19 ->
        act ! c4_t19;
        state = 56;
      fi
    }
  :: state == 46 ->
    atomic {
      if
      :: p4 ? c4_t2 ->
        act ! c4_t2;
        state = 47;
      fi
    }
  :: state == 51 ->
    atomic {
      if
      :: p4 ? c4_t7 ->
        act ! c4_t7;
        state = 48;
      fi
    }
  :: state == 54 ->
    atomic {
      if
      :: p4 ? c4_t12 ->
        act ! c4_t12;
        state = 55;
      :: p4 ? c4_t15 ->
        act ! c4_t15;
        state = 47;
      fi
    }
  :: state == 56 ->
    atomic {
      if
      :: p4 ? c4_t14 ->
        act ! c4_t14;
        state = 54;
      fi
    }
  :: state == 55 ->
    atomic {
      if
      :: p4 ? c4_t13 ->
        act ! c4_t13;
        state = 52;
      fi
    }
  :: state == 52 ->
    atomic {
      if
      :: p4 ? c4_t9 ->
        act ! c4_t9;
        state = 53;
      fi
    }
  :: state == 53 ->
    atomic {
      if
      :: p4 ? c4_t10 ->
        act ! c4_t10;
        state = 50;
      fi
    }
  od
}

/* Process 5 */
active proctype Proc5()
{
  int state = 60;
  do
  :: state == 60 ->
    atomic {
      if
      :: p5 ? nop ->

        state = 62;
      fi
    }
  :: state == 62 ->
    atomic {
      if
      :: p5 ? c5_t1 ->
        act ! c5_t1;
        state = 63;
      :: p5 ? c5_t3 ->
        act ! c5_t3;
        state = 64;
      fi
    }
  :: state == 63 ->
    atomic {
      if
      :: p5_2 ! c5_t2__c2_t9 ->

        state = 61;
      fi
    }
  :: state == 64 ->
    atomic {
      if
      :: p5 ? c5_t4 ->
        act ! c5_t4;
        state = 65;
      :: p5 ? c5_t9 ->
        act ! c5_t9;
        state = 68;
      fi
    }
  :: state == 61 ->
    atomic {
      if
      :: p5 ? c5_t6 ->
        act ! c5_t6;
        state = 66;
      :: p5_2 ! c5_t0__c2_t13 ->

        state = 62;
      fi
    }
  :: state == 65 ->
    atomic {
      if
      :: p5 ? c5_t5 ->
        act ! c5_t5;
        state = 61;
      fi
    }
  :: state == 68 ->
    atomic {
      if
      :: p5 ? c5_t10 ->
        act ! c5_t10;
        state = 66;
      fi
    }
  :: state == 66 ->
    atomic {
      if
      :: p5 ? c5_t11 ->
        act ! c5_t11;
        state = 67;
      :: p5_2 ! c2_t5__c5_t7 ->

        state = 62;
      fi
    }
  :: state == 67 ->
    atomic {
      if
      :: p5_1 ! c5_t8__c1_t2 ->

        state = 64;
      fi
    }
  od
}

#define p_c5_t10	 (lastAction == c5_t10)
#define p_c5_t9	 (lastAction == c5_t9)
#define p_c5_t5	 (lastAction == c5_t5)
#define p_c5_t4	 (lastAction == c5_t4)
#define p_c4_t18	 (lastAction == c4_t18)
#define p_c4_t14	 (lastAction == c4_t14)
#define p_c4_t13	 (lastAction == c4_t13)
#define p_c4_t15	 (lastAction == c4_t15)
#define p_c4_t19	 (lastAction == c4_t19)
#define p_c4_t12	 (lastAction == c4_t12)
#define p_c4_t9	 (lastAction == c4_t9)
#define p_c4_t6	 (lastAction == c4_t6)
#define p_c4_t7	 (lastAction == c4_t7)
#define p_c4_t3	 (lastAction == c4_t3)
#define p_c4_t2	 (lastAction == c4_t2)
#define p_c4_t1	 (lastAction == c4_t1)
#define p_c4_t5	 (lastAction == c4_t5)
#define p_c4_t0	 (lastAction == c4_t0)
#define p_c3_t11	 (lastAction == c3_t11)
#define p_c3_t8	 (lastAction == c3_t8)
#define p_c3_t5	 (lastAction == c3_t5)
#define p_c3_t4	 (lastAction == c3_t4)
#define p_c3_t12	 (lastAction == c3_t12)
#define p_c3_t0	 (lastAction == c3_t0)
#define p_c5_t2__c2_t9	 (lastAction == c5_t2__c2_t9)
#define p_c3_t3__c2_t10	 (lastAction == c3_t3__c2_t10)
#define p_c5_t0__c2_t13	 (lastAction == c5_t0__c2_t13)
#define p_c2_t6	 (lastAction == c2_t6)
#define p_c3_t7	 (lastAction == c3_t7)
#define p_c5_t1	 (lastAction == c5_t1)
#define p_c2_t4	 (lastAction == c2_t4)
#define p_c2_t0	 (lastAction == c2_t0)
#define p_c2_t12	 (lastAction == c2_t12)
#define p_c2_t8__c1_t4	 (lastAction == c2_t8__c1_t4)
#define p_c4_t4	 (lastAction == c4_t4)
#define p_c2_t5__c5_t7	 (lastAction == c2_t5__c5_t7)
#define p_c5_t8__c1_t2	 (lastAction == c5_t8__c1_t2)
#define p_c2_t7	 (lastAction == c2_t7)
#define p_c1_t5__c3_t10	 (lastAction == c1_t5__c3_t10)
#define p_c1_t8	 (lastAction == c1_t8)
#define p_c4_t17	 (lastAction == c4_t17)
#define p_c5_t6	 (lastAction == c5_t6)
#define p_c1_t6	 (lastAction == c1_t6)
#define p_c1_t3	 (lastAction == c1_t3)
#define p_c2_t14	 (lastAction == c2_t14)
#define p_c1_t1	 (lastAction == c1_t1)
#define p_c1_t0	 (lastAction == c1_t0)
#define p_c3_t6__c2_t2	 (lastAction == c3_t6__c2_t2)
#define p_c1_t7	 (lastAction == c1_t7)
#define p_c2_t1__c0_t3	 (lastAction == c2_t1__c0_t3)
#define p_c0_t0__c2_t3	 (lastAction == c0_t0__c2_t3)
#define p_c3_t9	 (lastAction == c3_t9)
#define p_c1_t9	 (lastAction == c1_t9)
#define p_c0_t7	 (lastAction == c0_t7)
#define p_c4_t10	 (lastAction == c4_t10)
#define p_c4_t16	 (lastAction == c4_t16)
#define p_c0_t9	 (lastAction == c0_t9)
#define p_c0_t6	 (lastAction == c0_t6)
#define p_c3_t1	 (lastAction == c3_t1)
#define p_c0_t5	 (lastAction == c0_t5)
#define p_c0_t4	 (lastAction == c0_t4)
#define p_c0_t8__c2_t11	 (lastAction == c0_t8__c2_t11)
#define p_c0_t2	 (lastAction == c0_t2)
#define p_c4_t8	 (lastAction == c4_t8)
#define p_c5_t3	 (lastAction == c5_t3)
#define p_c0_t1	 (lastAction == c0_t1)
#define p_c4_t11	 (lastAction == c4_t11)
#define p_c5_t11	 (lastAction == c5_t11)
#define p_c3_t2	 (lastAction == c3_t2)


ltl p1	{ (p_c4_t4 || p_c4_t5) V (!p_c2_t1__c0_t3 || p_c4_t4 || p_c4_t5) }	 /* true */
ltl p2	{ (p_c2_t5__c5_t7 || p_c5_t6) V (p_c2_t5__c5_t7 || !p_c5_t5 || p_c5_t6 || []!p_c0_t5) }	 /* false */
ltl p3	{ (p_c3_t5 || p_c5_t6) V (p_c3_t5 || p_c5_t6 || !p_c5_t11 || (p_c3_t7 V (!p_c3_t4 || p_c3_t7))) }	 /* false */
ltl p4	{ p_c4_t8 V (!p_c0_t6 || p_c4_t8) }	 /* true */
ltl p5	{ p_c5_t9 V (!p_c1_t5__c3_t10 || p_c5_t9 || []!p_c5_t1) }	 /* false */
ltl p6	{ []((!p_c0_t7 || []!p_c0_t4) && (!p_c0_t2 || (!p_c0_t5 U p_c4_t6))) }	 /* true */
ltl p7	{ [](!p_c2_t8__c1_t4 && (!p_c3_t0 || []!p_c1_t5__c3_t10)) }	 /* false */
ltl p8	{ [](!p_c5_t10 || []!p_c3_t2) }	 /* false */
ltl p9	{ [](!p_c5_t2__c2_t9 && (!p_c2_t12 || []!p_c1_t5__c3_t10)) }	 /* true */
ltl p10	{ [](!p_c2_t5__c5_t7 || (p_c5_t6 V (!p_c5_t2__c2_t9 || p_c5_t6))) }	 /* true */
ltl p11	{ (p_c3_t4 || p_c5_t10) V (p_c3_t4 || !p_c5_t5 || p_c5_t10 || []!p_c3_t5) }	 /* false */
ltl p12	{ []((!p_c3_t0 || []!p_c3_t6__c2_t2) && (!p_c5_t11 || []!p_c3_t9)) }	 /* false */
ltl p13	{ [](!p_c1_t3 || <>p_c1_t0) }	 /* false */
ltl p14	{ p_c4_t8 V (!p_c0_t8__c2_t11 || p_c4_t8 || (p_c4_t19 V (!p_c4_t12 || p_c4_t19))) }	 /* true */
ltl p15	{ [](!p_c0_t8__c2_t11 || <>p_c4_t17) }	 /* true */
ltl p16	{ []((!p_c5_t5 || (p_c2_t8__c1_t4 V (!p_c2_t6 || p_c2_t8__c1_t4))) && (!p_c5_t6 || (p_c5_t11 V (!p_c5_t1 || p_c5_t11)))) }	 /* false */
ltl p17	{ p_c1_t5__c3_t10 V (p_c1_t5__c3_t10 || !(p_c2_t1__c0_t3 || p_c2_t8__c1_t4)) }	 /* true */
ltl p18	{ p_c4_t17 V (!p_c4_t4 || p_c4_t17 || []!p_c5_t8__c1_t2) }	 /* false */
ltl p19	{ []((!p_c0_t5 || []!p_c5_t5) && (!p_c0_t7 || <>p_c2_t1__c0_t3)) }	 /* false */
ltl p20	{ (p_c3_t1 || p_c3_t3__c2_t10) V (p_c3_t1 || p_c3_t3__c2_t10 || !p_c5_t0__c2_t13 || (!p_c3_t12 U p_c2_t8__c1_t4)) }	 /* true */
